Gecode::Int::Element::View< VA, VB, VC, pc_ac > Class Template Reference

Base-class for element propagator for array of views. More...

`#include <element.hh>`

## Public Member Functions

virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function.
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Member Functions

| View (Space &home, View &p)
| Constructor for cloning p.
| View (Home home, IdxViewArray< VA > &iv, VB x0, VC x1)
| Constructor for creation.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

IdxViewArray< VA > | iv
| Current index-view map.
VB | x0
| View for index.
VC | x1
| View for result.

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Detailed Description

template<class VA, class VB, class VC, PropCond pc_ac>
class Gecode::Int::Element::View< VA, VB, VC, pc_ac >

Base-class for element propagator for array of views.

Definition at line 203 of file element.hh.

## Constructor & Destructor Documentation

## View() [1/2]

template<class VA, class VB, class VC, PropCond pc_ac>

Gecode::Int::Element::View< VA, VB, VC, pc_ac >::View | ( | Space & | home,
|  | View< VA, VB, VC, pc_ac > & | p )

inline protected

Constructor for cloning p.

Definition at line 122 of file view.hpp.

## View() [2/2]

template<class VA, class VB, class VC, PropCond pc_ac>

Gecode::Int::Element::View< VA, VB, VC, pc_ac >::View | ( | Home | home,
|  | IdxViewArray< VA > & | iv,
|  | VB | x0,
|  | VC | x1 )

protected

Constructor for creation.

Definition at line 112 of file view.hpp.

## Member Function Documentation

## cost()

template<class VA, class VB, class VC, PropCond pc_ac>

PropCost Gecode::Int::Element::View< VA, VB, VC, pc_ac >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function.

Implements Gecode::Propagator.

Reimplemented in Gecode::Int::Element::ViewDom< VA, VB, VC >.

Definition at line 131 of file view.hpp.

## reschedule()

template<class VA, class VB, class VC, PropCond pc_ac>

void Gecode::Int::Element::View< VA, VB, VC, pc_ac >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 140 of file view.hpp.

## dispose()

template<class VA, class VB, class VC, PropCond pc_ac>

size_t Gecode::Int::Element::View< VA, VB, VC, pc_ac >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 148 of file view.hpp.

## Member Data Documentation

## iv

template<class VA, class VB, class VC, PropCond pc_ac>

IdxViewArray<VA> Gecode::Int::Element::View< VA, VB, VC, pc_ac >::iv

protected

Current index-view map.

Definition at line 206 of file element.hh.

## x0

template<class VA, class VB, class VC, PropCond pc_ac>

VB Gecode::Int::Element::View< VA, VB, VC, pc_ac >::x0

protected

View for index.

Definition at line 208 of file element.hh.

## x1

template<class VA, class VB, class VC, PropCond pc_ac>

VC Gecode::Int::Element::View< VA, VB, VC, pc_ac >::x1

protected

View for result.

Definition at line 210 of file element.hh.

The documentation for this class was generated from the following files:

- gecode/int/element.hh
- gecode/int/element/view.hpp